
<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

    <title>Contributing &#8212; Phenotastic 0.3.0 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/classic.css" />

    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/sphinx_highlight.js"></script>

    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Credits" href="authors.html" />
    <link rel="prev" title="phenotastic package" href="phenotastic.html" />
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="authors.html" title="Credits"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="phenotastic.html" title="phenotastic package"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">Phenotastic 0.3.0 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Contributing</a></li>
      </ul>
    </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">

  <section id="contributing">
<h1>Contributing<a class="headerlink" href="#contributing" title="Permalink to this heading">¶</a></h1>
<p>Contributions are welcome, and they are greatly appreciated! Every little bit
helps, and credit will always be given.</p>
<p>You can contribute in many ways:</p>
<section id="types-of-contributions">
<h2>Types of Contributions<a class="headerlink" href="#types-of-contributions" title="Permalink to this heading">¶</a></h2>
<section id="report-bugs">
<h3>Report Bugs<a class="headerlink" href="#report-bugs" title="Permalink to this heading">¶</a></h3>
<p>Report bugs at <a class="reference external" href="https://github.com/supersubscript/phenotastic/issues">https://github.com/supersubscript/phenotastic/issues</a>.</p>
<p>If you are reporting a bug, please include:</p>
<ul class="simple">
<li><p>Your operating system name and version.</p></li>
<li><p>Any details about your local setup that might be helpful in troubleshooting.</p></li>
<li><p>Detailed steps to reproduce the bug.</p></li>
</ul>
</section>
<section id="fix-bugs">
<h3>Fix Bugs<a class="headerlink" href="#fix-bugs" title="Permalink to this heading">¶</a></h3>
<p>Look through the GitLab issues for bugs. Anything tagged with “bug” and “help
wanted” is open to whoever wants to implement it.</p>
</section>
<section id="implement-features">
<h3>Implement Features<a class="headerlink" href="#implement-features" title="Permalink to this heading">¶</a></h3>
<p>Look through the GitHub issues for features. Anything tagged with “enhancement”
and “help wanted” is open to whoever wants to implement it.</p>
</section>
<section id="write-documentation">
<h3>Write Documentation<a class="headerlink" href="#write-documentation" title="Permalink to this heading">¶</a></h3>
<p>Phenotastic could always use more documentation, whether as part of the
official Phenotastic docs, in docstrings, or even on the web in blog posts,
articles, and such.</p>
</section>
<section id="submit-feedback">
<h3>Submit Feedback<a class="headerlink" href="#submit-feedback" title="Permalink to this heading">¶</a></h3>
<p>The best way to send feedback is to file an issue at <a class="reference external" href="https://github.com/supersubscript/phenotastic/issues">https://github.com/supersubscript/phenotastic/issues</a>.</p>
<p>If you are proposing a feature:</p>
<ul class="simple">
<li><p>Explain in detail how it would work.</p></li>
<li><p>Keep the scope as narrow as possible, to make it easier to implement.</p></li>
<li><p>Remember that this is a volunteer-driven project, and that contributions
are welcome :)</p></li>
</ul>
</section>
</section>
<section id="get-started">
<h2>Get Started!<a class="headerlink" href="#get-started" title="Permalink to this heading">¶</a></h2>
<p>Ready to contribute? Here’s how to set up <cite>phenotastic</cite> for local development.</p>
<ol class="arabic">
<li><p>Fork the <cite>phenotastic</cite> repo on GitLab.</p></li>
<li><p>Clone your fork locally:</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>git<span class="w"> </span>clone<span class="w"> </span>git@gitlab.com:your_name_here/phenotastic.git
</pre></div>
</div>
</li>
<li><p>Install your local copy into a virtualenv. Assuming you have virtualenvwrapper installed, this is how you set up your fork for local development:</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>mkvirtualenv<span class="w"> </span>phenotastic
$<span class="w"> </span><span class="nb">cd</span><span class="w"> </span>phenotastic/
$<span class="w"> </span>python<span class="w"> </span>setup.py<span class="w"> </span>develop
</pre></div>
</div>
</li>
<li><p>Create a branch for local development:</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>git<span class="w"> </span>checkout<span class="w"> </span>-b<span class="w"> </span>name-of-your-bugfix-or-feature
</pre></div>
</div>
<p>Now you can make your changes locally.</p>
</li>
<li><p>When you’re done making changes, check that your changes pass flake8 and the
tests, including testing other Python versions with tox:</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>flake8<span class="w"> </span>phenotastic<span class="w"> </span>tests
$<span class="w"> </span>python<span class="w"> </span>setup.py<span class="w"> </span><span class="nb">test</span><span class="w"> </span>or<span class="w"> </span>py.test
$<span class="w"> </span>tox
</pre></div>
</div>
<p>To get flake8 and tox, just pip install them into your virtualenv.</p>
</li>
<li><p>Commit your changes and push your branch to GitHub:</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>git<span class="w"> </span>add<span class="w"> </span>.
$<span class="w"> </span>git<span class="w"> </span>commit<span class="w"> </span>-m<span class="w"> </span><span class="s2">&quot;Your detailed description of your changes.&quot;</span>
$<span class="w"> </span>git<span class="w"> </span>push<span class="w"> </span>origin<span class="w"> </span>name-of-your-bugfix-or-feature
</pre></div>
</div>
</li>
<li><p>Submit a pull request through the GitHub website.</p></li>
</ol>
</section>
<section id="pull-request-guidelines">
<h2>Pull Request Guidelines<a class="headerlink" href="#pull-request-guidelines" title="Permalink to this heading">¶</a></h2>
<p>Before you submit a pull request, check that it meets these guidelines:</p>
<ol class="arabic simple">
<li><p>The pull request should include tests.</p></li>
<li><p>If the pull request adds functionality, the docs should be updated. Put
your new functionality into a function with a docstring, and add the
feature to the list in README.rst.</p></li>
<li><p>The pull request should work for Python 2.7, and 3.6, and for PyPy. Check
<a class="reference external" href="https://travis-ci.org/supersubscript/phenotastic/pull_requests">https://travis-ci.org/supersubscript/phenotastic/pull_requests</a>
and make sure that the tests pass for all supported Python versions.</p></li>
</ol>
</section>
<section id="tips">
<h2>Tips<a class="headerlink" href="#tips" title="Permalink to this heading">¶</a></h2>
<p>To run a subset of tests:</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>py.test<span class="w"> </span>tests.test_phenotastic
</pre></div>
</div>
</section>
<section id="deploying">
<h2>Deploying<a class="headerlink" href="#deploying" title="Permalink to this heading">¶</a></h2>
<p>A reminder for the maintainers on how to deploy.
Make sure all your changes are committed (including an entry in HISTORY.rst).
Then run:</p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>bumpversion<span class="w"> </span>patch<span class="w"> </span><span class="c1"># possible: major / minor / patch</span>
$<span class="w"> </span>git<span class="w"> </span>push
$<span class="w"> </span>git<span class="w"> </span>push<span class="w"> </span>--tags
</pre></div>
</div>
<p>Travis will then deploy to PyPI if tests pass.</p>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <div>
    <h3><a href="index.html">Table of Contents</a></h3>
    <ul>
<li><a class="reference internal" href="#">Contributing</a><ul>
<li><a class="reference internal" href="#types-of-contributions">Types of Contributions</a><ul>
<li><a class="reference internal" href="#report-bugs">Report Bugs</a></li>
<li><a class="reference internal" href="#fix-bugs">Fix Bugs</a></li>
<li><a class="reference internal" href="#implement-features">Implement Features</a></li>
<li><a class="reference internal" href="#write-documentation">Write Documentation</a></li>
<li><a class="reference internal" href="#submit-feedback">Submit Feedback</a></li>
</ul>
</li>
<li><a class="reference internal" href="#get-started">Get Started!</a></li>
<li><a class="reference internal" href="#pull-request-guidelines">Pull Request Guidelines</a></li>
<li><a class="reference internal" href="#tips">Tips</a></li>
<li><a class="reference internal" href="#deploying">Deploying</a></li>
</ul>
</li>
</ul>

  </div>
  <div>
    <h4>Previous topic</h4>
    <p class="topless"><a href="phenotastic.html"
                          title="previous chapter">phenotastic package</a></p>
  </div>
  <div>
    <h4>Next topic</h4>
    <p class="topless"><a href="authors.html"
                          title="next chapter">Credits</a></p>
  </div>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/contributing.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="authors.html" title="Credits"
             >next</a> |</li>
        <li class="right" >
          <a href="phenotastic.html" title="phenotastic package"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">Phenotastic 0.3.0 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Contributing</a></li>
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2018, Henrik Ahl.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 6.1.3.
    </div>
  </body>
</html>
